package de.hdm_stuttgart.sw1.klausur.test;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.exam.MarkingTest;
import de.hdm_stuttgart.sw1.klausur.string.StringHelper;

@SuppressWarnings({ "static-method", "javadoc" })
public class TestSummierteWortlaenge extends MarkingTest {

	private static void pruefeErwarteteLaenge(final String[] s, int erwarteteLaenge) {
		Assert.assertEquals("Wortliste '" + Helper.toString(s) + "' hat erwartete Gesamtlänge " + erwarteteLaenge,
				erwarteteLaenge,
				StringHelper.summierteWortLaenge(s));
	}
	
	@Test
	public void testNull() {
		Assert.assertEquals("Ein null String hat die Länge 0", 0,
				StringHelper.summierteWortLaenge(null));
	}

	@Test
	public void summierteWortLaengeNonNull() {
		
		pruefeErwarteteLaenge(new String[] {}, 0);
		pruefeErwarteteLaenge(new String[] { "" }, 0);
		pruefeErwarteteLaenge(new String[] { "Einfach" }, 7);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", ", doppelt" }, 18);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", ", doppelt", ", dreifach" }, 28);
	}

	@Test
	public void testMixedNull() {
		
		pruefeErwarteteLaenge(new String[] { null }, 0);
		pruefeErwarteteLaenge(new String[] { null, null }, 0);
		pruefeErwarteteLaenge(new String[] { "Einfach", null }, 7);
		pruefeErwarteteLaenge(new String[] { "Einfach, ", null, ", doppelt" }, 18);
		pruefeErwarteteLaenge(new String[] { null, "Einfach, ", null, ", doppelt"}, 18);
		pruefeErwarteteLaenge(new String[] { null, "Einfach, ", null, ", doppelt", ", dreifach", null }, 28);
		pruefeErwarteteLaenge(new String[] { "Dies", " ist ", " kurz.", null }, 15);
	}
}
